plugins['phonepro'] = (function() {

    //var transfer_code  = pluginconfig['phone']['transfer_code'][''];
    var force_autoanswer = pluginconfig['phonepro']['force_autoanswer'];
    var hasvoicemail=0;
    var voicemaillicense=0;

    return { 

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~phonepro" + "|" + hash + "\" />";
            sendcommand();
        },
        setLang: function() {
           $('#phoneframeTitle').html(lang.phone);
        },
        init: function() {

        },
        getContactId: function(number,firstname,lastname,channel) {
            return new Promise((resolve,reject) => {
              $.ajax({
                data: {
                    id: number,
                    firstname: firstname,
                    lastname: lastname,
                    channel: channel

                },
                url: "vphonebook.php",
                success: function(output) {
                    resolve(output)
                },
                error: function(error) {
                    reject(error)
                }
             })
          })
        },
        hasVoicemailLicense: function() {
            return voicemaillicense;
        },
        hasVoicemail: function() {
            return hasvoicemail;
        },
        getImage: function(number) {
            return new Promise((resolve,reject) => {
              $.ajax({
                data: {
                    image: number
                },
                url: "vphonebook.php",
                success: function(output) {
                    resolve(output)
                },
                error: function(error) {
                    reject(error)
                }
             })
          })
        },
        notify_popup: function(type,title,text,icon) {
             // inbound call notification
             console.log('phone popup '+type+', title '+title+',text '+text+', icon '+icon);
             const regex = new RegExp('user.png$');
             if(regex.test(icon)===false) {
                 partes = text.split(" ");
                 var iframe = $('#phoneproiframe');
                 $('#invitecontact_'+partes[0], iframe.contents()).attr('src',icon);
             }
        },
        callback_DELIVERYFAIL: function(nro,texto,slot) {
            console.log("delivery fail "+texto);
            var iframe = $('#phoneproiframe');
            setTimeout(function() {
                msgid = iframe.contents().find('div[data-tag="'+texto+'"]').attr('id').substr(4);
                console.log('fail id '+msgid);
                iframe[0].contentWindow.markMessageFail(msgid);
            },1000);
        },
        callback_voicemailenabled: function(nro,texto,slot) {
            if(nro==myposition) {
                if(texto=="1") {
                    hasvoicemail=1;
                    console.log("TENGO VOICEMAIL voicemail");
                }
            }
        },
        callback_notionline: function(nro,texto,slot) {

            debug("phone callback notionline my position="+myposition+" and texto = "+texto);

            if(myposition==texto) {
               if(typeof(sipcredentials)=='string') {
                    // prevent positions popup to show on fop2 server reload
                } else {
                    send("<msg data=\""+myposition+"!"+myextension+"|prosipcredentials|0\" />");
                }
            }
        },
        callback_zbuttons: function(nro,texto,slot) {

           if (!(jQuery.inArray('phone', permisos) >= 0 || jQuery.inArray('all', permisos) >= 0)) {
               debug('User does not have phone permissions!');
               return;
           }

           if($('#box_phoneframebox').length<=0) {

               // New bootstrap client
               var newklon = $('<div class="grid-stack-item" id="box_phoneframebox" ><div class="grid-stack-item-content boxstyle boxstylebg"><div id="phoneframecontent" class="widgetcontent widget widget-color"><header role="heading"><div class="widget-ctrls" role="menu"><a class="myclick button-icon widget-toggle-btn langcollapse" data-toggle="tooltip" rel="tooltip" title="" data-placement="bottom" data-original-title="Collapse"><i class="fa fa-caret-square-o-up"></i></a><a class="myclick button-icon widget-lock-btn langlockunlock" data-toggle="tooltip" rel="tooltip" title="" data-placement="bottom" data-original-title="Lock/Unlock"><i class="fa fa-unlock-alt"></i></a></div><span class="handle widget-icon"><i class="fa fa-bars"></i></span><h3><span id="phoneframeTitle">Phone</span></h3></header><div class="widgetnoscroll" id="phoneframelist" style="height:100%;"><iframe id="phoneproiframe" name="phoneproiframe" data-isloaded="0" sandbox="allow-modals allow-downloads allow-same-origin allow-scripts allow-popups allow-forms" style="width:100%; height:100%; min-height:500px; border:0; overflow-y: hidden;"></iframe><form id="phonevariables" method="post" target="phoneproiframe" action="admin/plugins/phonepro/webrtcphone/index.php"><input type=hidden name="phone_login" id="phone_login" value=""><input type=hidden name="phone_pass" id="phone_pass" value=""><input type=hidden name="server" id="server" value=""></form></div></div></div></div>');
               grid = $('.grid-stack').data('gridstack');

               window.resizinggrid=1;
               if(parseInt(currentrelease.replace(/\./g,''))>23101) {
                   grid.addWidget(newklon,0,0,3,6,true);
               } else {
                   grid.add_widget(newklon,0,0,3,6,true);
               }
               restoreGrid(Base64.decode(mypreferences.grid));
               window.resizinggrid=0;
               $('#box_phoneframebox [data-toggle="tooltip"]').tooltip({container:'body'});

               window.resizinggrid=1;
               var jsongrid = Base64.decode(mypreferences.grid);
               grid.batchUpdate();
               if(jsongrid.length>0) {
                   try {
                       var dita = JSON.parse(jsongrid);
                       for (var item in dita) {
                           if(dita[item].id=='box_phoneframebox') {
                               grid.update($('#'+dita[item].id),dita[item].x,dita[item].y,dita[item].width,dita[item].height);
                           }
                       }
                   } catch(e) {
                       debug('phone Invalid JSON in grid pref');
                   }
               }
               grid.commit();
               window.resizinggrid=0;

               // hide dialbox and dialpad from regular FOP2 gui, handle those from phone plugin
               //$('#dialtext').parent().parent().remove();
               //$('.navinputfilter').css('width','238px');
               $('.dialpad-dropdown').hide();

           }
           // hide toolbar elements
           if($('#extensionbox').is(':visible')) { 
               $('#extensionbox').hide();
               $('#actionbar').hide(); 
               $('.navinputfilter').hide(); 
               $('.navinputdial').hide(); 
               $('.toolbarpad').children().eq(2).css('position','absolute').css('right','5px');
               $('#dialfilterbar').css('position','absolute').css('left','10px');
               //$('.navinputpresence').css('padding-left','5px');
               //$('.toolbarpad').children().eq(0).removeClass('col-xs-12 col-sm-6 col-md-6 col-lg-6').attr('style','display: none !important');
               //$('.toolbarpad').children().eq(1).removeClass('col-xs-12 col-sm-4 col-md-4 col-lg-4');
               //$('.toolbarpad').children().eq(1).addClass('col-xs-10 col-sm-10 col-md-10 col-lg-10');
               //$('.toolbarpad').children().eq(2).css('padding-right','5px').removeClass('hidden-xs');
           }
           $('#slider').slideReveal('show');


           // droppable for voicemail
           $('#phoneproiframe').on('load', function() {

               $('#phoneproiframe').contents().find("#tabnav .tab").droppable({
                   hoverClass: 'tabhover',
                   drop: function(event, ui) {
                       debug(ui.draggable[0].id + ' dropped on ' + $(this).attr('id'));
                       partesElement = ui.draggable[0].id.split("_");
                       partesDest = $(this).attr('id').split("_");
                       if (partesElement[1] != partesDest[1]) {
                           debug("Muevo mensaje " + partesElement[2] + " a carpeta " + partesDest[1]);
                           var mennum = '' + partesElement[2];
                           var originfolder = partesElement[1];
                           var destinationfolder = partesDest[1];
                           moveVoicemail(mennum, originfolder, destinationfolder);
                       }
                   }
               });
       
               $('#phoneproiframe').contents().find("#vmail_trash").droppable({
                   hoverClass: 'trashfullicon',
                   drop: function(event, ui) {
                       debug(ui.draggable[0].id + ' dropped on ' + $(this).attr('id'));
                       partesElement = ui.draggable[0].id.split("_");
                       partesDest = $(this).attr('id').split("_");
                       if (partesElement[1] != partesDest[1]) {
                           debug("Muevo mensaje " + partesElement[2] + " a carpeta " + partesDest[1]);
                           var mennum = '' + partesElement[2];
                           var originfolder = partesElement[1];
                           moveVoicemail(mennum, originfolder, "");
                       }
                   }
               });


           });
    


        },
        callback_vmaildetail: function(nro,texto,slot) {
            console.log("vmaildetail in phonepro for nro "+nro+" and myposition "+myposition);
            if(nro != myposition) {
                console.log("return on nro not equal to myposition");
                  return;
            }
            partes = texto.split("!");
            folder = partes[0];
            datos = Base64.decode(partes[1]);

            $('#panel_' + folder).html('');

            var data = jQuery.parseJSON(datos);
            console.log(data);
            var resp = "<div class='xstable'><table id='vmtable_"+folder+"' class='table table-striped historychat'>";
            resp += "<thead><tr><th style='width:1.5rem'></th><th style='width:1.5rem'></th><th style='width:1.5rem;'>" + lang.vmail_number + "</th><th>" + lang.vmail_date + "</th><th>" + lang.vmail_callerid + "</th><th>" + lang.vmail_duration + "</th></tr></thead>";
            resp += "<tbody id='table_" + folder + "' class='hasdrag'>";
            drags = [];
            for (a = 0; a < data[folder].length; a++) {
                if (data[folder][a]['callerid']) {
                    var num = a + 1;
                    var mid = '';
                    if (data[folder][a]['msgid'] === undefined) {
                        mid = "" + data[folder][a]['id'];
                    } else {
                        mid = "" + data[folder][a]['msgid'];
                    }
                    drags.push("drag_" + folder + "_" + mid);
                    if (a % 2) {
                          rowclass = "odd";
                    } else {
                          rowclass = "data";
                    }
                    var millitime = data[folder][a]['origtime'] * 1000;
                    var mdate = new Date(millitime);
                    var options = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric',hour: '2-digit', minute:'2-digit' };
                    var tzdate = mdate.toLocaleDateString(navigator.language,options);

                    var transcript = data[folder][a]['transcript'];
                    if(typeof transcript==='undefined') { transcript=''; }

                    resp += "<tr class='" + rowclass + " xvmdraggable' id='drag2_" + folder + "_" + mid + "'>";
                    resp += "<td><i class='vmdraggable fas fa-arrows-alt' style='cursor:move;' aria-hidden='true' data-num='"+num+"' id='drag_"+folder+"_"+mid+"'></i></td>";
                    resp += "<td>";
                    resp += "<div onclick='javascript:playVmail(\"" + folder + "\",\"" + mid + "\",\"playvm_" + folder + "_" + a + "\");' class='audioButton' data-toggle='tooltip' data-original-title='" + lang.play + "' id='wrap_playvm_" + folder + "_" + a + "'>";
                    resp += "<i id='playvm_"+folder+"_"+a+"' class='fa fa-play-circle playpause'></i>";
                    resp += "</div>";
                    if(transcript!='') {
                        resp += "<i style='font-size: 1.3em; margin-top:2px; margin-left:2px;' class='fa fa-info-circle transcript-tooltip' data-placement='right' data-trigger='hover' data-toggle='popover' title='Transcript' data-content='"+transcript+"'></i>";
                    }
                    resp += "</td>";
                    resp += "<td><span class='msgnum'>" + num + "</span></td>";
                    resp += "<td>" + tzdate + "</td><td>" + data[folder][a]['callerid'] + "</td>";
                    resp += "<td>" + data[folder][a]['duration'] + " secs.</td></tr>";
                }
            }
            resp += "</tbody></table></div>";
            resp += "<form id='dloadfrm_"+folder+"' method='post' onsubmit='resetExit();'><input type=hidden id='file' name='file'/></form>";
            $('#panel_' + folder).html(resp);
            $('#phoneproiframe').contents().find('#panel_'+folder).html(resp).css('opacity','1');
            
            $('#phoneproiframe').contents().find(".vmdraggable").draggable({
                scroll: false,
                helper: function() {
                    //return $("<div class='mailicon' style='visibility:visible;'></div>").append($(this).find('.msgnum').clone().css({fontWeight: 'bold', marginLeft:'5px', marginTop:'3px'}));
                    return $("<div class='mailicon' style='visibility:visible;'></div>").append('<span style="font-weight:bold;margin-left:5px;margin-top:3px;position:fixed;">'+$(this).data('num')+'</span>');
                },
                cursorAt: {
                  left: 24
                }
            });

            $('#phoneproiframe').contents().find('#panel_' + folder).find('table').each(function() {

                var currentPage = 0;
                var numPerPage = 10;
                var $table = $(this);
                if (typeof curVmailPage['panel_' + folder] != 'undefined') {
                    currentPage = curVmailPage['panel_' + folder];
                }
                $table.bind('repaginate', function() {
                    $table.find('tbody tr').hide().slice(currentPage * numPerPage, (currentPage + 1) * numPerPage).show();
                });
                var numRows = $table.find('tbody tr').length;
                var numPages = Math.ceil(numRows / numPerPage);
                if(currentPage > numPages) { currentPage=numPages-1; }
                $table.trigger('repaginate');

                var $pager = $('<ul class="pagination"></ul>');
                var navcont = $('<nav class="text-center"></nav>');
                $pager.appendTo(navcont);

                if(numPages > 1) {
                    for (var page = 0; page < numPages; page++) {
                        var li = $('<li></li>');
                        $('<a class="page-number pg_' + (page + 1) + '"></a>').text(page + 1).bind('click', {
                            newPage: page
                        }, function(event) {
                            currentPage = event.data['newPage'];
                            $table.trigger('repaginate');
                            $(this).parent().addClass('active').siblings().removeClass('active');
                            curVmailPage[$(this).parent().parent().parent().attr('id')] = currentPage;
                        }).appendTo(li).addClass('clickable');
                        li.appendTo($pager);
                    }
                    navcont.insertAfter($table);
                    $('<hr>').insertAfter($table);
                    $pager.find('a.pg_' + (currentPage + 1)).parent().addClass('active').siblings().removeClass('active');
                }
            });

            $('#phoneproiframe').contents().find('#vmtable_'+folder+' [data-toggle="tooltip"]').tooltip();

                    //setThisTip('vmtable');
                    //$('[data-toggle="popover"]').popover({ container: 'body' });

            // var iframe = document.getElementById("phoneproiframe");
            // iframe.contentWindow.setVmailDroppable(folder);
        },
        callback_PhoneNoLicense: function(nro,texto,slot) {
            if(myposition==nro) {
                $('#phoneproiframe').contents().find('head').html('<link rel="stylesheet" href="css/bootstrap.min.css"></link>');
                $('#phoneproiframe').contents().find('body').html('<div class="alert alert-warning text-center" style="margin:10px;"><h3>'+lang.nomorelicenses+'</h3></div>');
            }
        },
        callback_PhoneproVoicemail: function(nro,texto,slot) {
            voicemaillicense=texto;
        },
        callback_SIPCredentials: function(nro,texto,slot) {
            if(myposition==nro) {
                sipcredentials = texto;
                var decoded = Base64.decode(texto);
                var pl = decoded.split('^')[0];
                var pp = decoded.split('^')[1];
                $('#phone_login').val(pl);
                $('#phone_pass').val(pp);
                $('#server').val(window.location.hostname);
                if(pl!='' && pp!='') {
                    $('#phonevariables').submit();
                }
            }
        }
    }
}());
