function render() {
    var sub_ul = $('<ul class="ulline">');    
    var act_div =  $('<div>');
    cont=0;
    let invites = {};
    let conferences = [];
    var conf_handlers = [];
    Object.keys(activeCalls).forEach( id => {
        if(id!==undefined) {
            part = [];
            part.push(activeCalls[id].remoteIdentity.uri.raw.user);
            part.push(activeCalls[id].remoteIdentity._displayName);
            elapsed    = Math.round(Date.now()/1000)-activeCalls[id].startTime;
            hold_icon  = (activeCalls[id].isOnHold)?'fa-play':'fa-pause';
            mute_icon  = (activeCalls[id].isMuted)?'fa-microphone-slash text-danger':'fa-microphone text-info';
            time_print = defaultFormat(elapsed);
            name_print = part.join(' ');
            isSelected='';

            // save events for conference buttons, to restore upon redraw
            if(typeof(activeCalls[id].sessdata.confcalls)!='undefined') {
                if(activeCalls[id].sessdata.confcalls.length>0) {
                    conferences.push(id);
                    if(typeof($._data($('#btncajoinconf_'+id).get(0),'events'))!='undefined') {
                        $.each($._data($('#btncajoinconf_'+id).get(0),'events'), function() {
                            $.each(this, function() {
                                conf_handlers['#btncajoinconf_'+id]={type:this.type,handler:this.handler};
                            });
                        });
                    }
                    if(typeof($._data($('#btnjoin_'+id).get(0),'events'))!='undefined') {
                        $.each($._data($('#btnjoin_'+id).get(0),'events'), function() {
                            $.each(this, function() {
                                conf_handlers['#btnjoin_'+id]={type:this.type,handler:this.handler};
                            });
                        });
                    }
                    if(typeof($._data($('#btnfinishconf_'+id).get(0),'events'))!='undefined') {
                        $.each($._data($('#btnfinishconf_'+id).get(0),'events'), function() {
                            $.each(this, function() {
                                conf_handlers['#btnfinishconf_'+id]={type:this.type,handler:this.handler};
                            });
                        });
                    }
                }
            }

            if(selectedLine==id) { isSelected='selected'; } 
            if(activeCalls[id]._state != 'Initial') {
                cont++;
                var sub_li = $('<li class="liline '+isSelected+'" id="line_'+id+'"><div class="circle">'+id+'</div><div class="callid">'+name_print+'</div><div class="timer" id="timer_'+id+'">'+time_print+'</div></li>');

                var action_row = $(`
                <div id='actn_${id}' class='actionrow'>
                  <div id='actionbuttons_${id}'>
                    <a class="holdbutton requireconnect${id}" data-toggle="tooltip" data-placement="bottom" title="${parent.lang.holdunhold}" id="btnhl_${id}"><span class="fa-stack fa"><i class="fa fa-circle fa-stack-2x text-gray"></i><i class="fa ${hold_icon} fa-stack-1x" ></i></span></a>
                    <a class="mutebutton requireconnect${id}" data-toggle="tooltip" data-placement="bottom" title="${parent.lang.muteunmute}" id="btnmu_${id}"><span class="fa-stack fa"><i class="fa fa-circle fa-stack-2x text-gray"></i><i class="fa ${mute_icon} fa-stack-1x" ></i></span></a>
                    <a class="transferbutton requireconnect${id}" data-toggle="tooltip" data-placement="bottom" title="${parent.lang.transfer}" id="btntr_${id}"><span class="fa-stack fa"><i class="fa fa-circle fa-stack-2x text-gray"></i><i class="fa fa-phone fa-stack-1x" style='transform:rotate(135deg); left:-5px;'></i><i class="fa fa-arrow-right fa-stack-1x" style='transform:scale(0.5); left:-2px;'></i><i class="fa fa-phone fa-stack-1x" style="transform:rotate(135deg); left:6px;"></i></span></a>
                    <a class="conferencebutton requireconnect${id}" data-toggle="tooltip" data-placement="bottom" title="${parent.lang.conference}" id="btntr_${id}"><span class="fa-stack fa"><i class="fa fa-circle fa-stack-2x text-gray"></i><i class="fa fa-users fa-stack-1x"></i></span></a>
                    <a class="hangupbutton" data-toggle="tooltip" data-placement="bottom" title="${parent.lang.hangup}" id="btnhp_${id}"><span class="fa-stack fa"><i class="fa fa-circle fa-stack-2x text-danger"></i><i class="fa fa-phone fa-stack-1x fa-inverse"  style="transform: rotate(225deg);" ></i></span></a>
                  </div>
                  <div class="form-group text-center transferbox" id="transferbox_${id}" style="display:none;">
                    <input type=text id="target_${id}" onclick="event.stopPropagation()" placeholder='${parent.lang.transferto}' name='target_${id}' class='transfertarget form-control'>
                    <div class='mb-5 mt-5' style="line-height: 1.8em;">
                      <button class="transfer_stage1 btransfer btn btn-xs btn-primary" id="btnbtransfer_${id}">${parent.lang.blindtransfer}</button>
                      <button class="transfer_stage1 stransfer btn btn-xs btn-primary" id="btnstransfer_${id}">${parent.lang.supervisedtransfer}</button>
                      <button class="transfer_stage1 canceltransfer btn btn-xs btn-danger" id="btncatrans_${id}">${parent.lang.canceltransfer}</button>
                      <button class="transfer_stage2 completetransfer btn btn-xs btn-success" style="display:none;" id="btncomplete_${id}">${parent.lang.completetransfer}</button>
                      <button class="transfer_stage2 cancelsupertransfer btn btn-xs btn-warning" style="display:none;" id="btncasutrans_${id}">${parent.lang.canceltransfer}</button>
                    </div>
                  </div>
                  <div class="form-group text-center conferencebox" id="conferencebox_${id}" style="display:none;">
                    <input type=text id="conftarget_${id}" onclick="event.stopPropagation()" placeholder='${parent.lang.conferencewith}' name='conftarget_${id}' class='conferencetarget form-control'>
                    <div class='mb-5 mt-5' style="line-height: 1.8em;">
                      <button class="conference_stage1 bconference btn btn-xs btn-primary" id="btnconference_${id}">${parent.lang.call}</button>
                      <button class="conference_stage1 cancelconference1 btn btn-xs btn-danger" id="btncaconf_${id}">${parent.lang.cancel}</button>
                      <button class="conference_stage2 joinconference btn btn-xs btn-success" style="display:none;" id="btnjoin_${id}">${parent.lang.joinconference}</button>
                      <button class="conference_stage2 cancelconference2 btn btn-xs btn-warning" style="display:none;" id="btncajoinconf_${id}">${parent.lang.cancelcall}</button>
                      <button class="conference_stage2 terminateconference2 btn btn-xs btn-warning" style="display:none;" id="btnfinishconf_${id}">${parent.lang.finishconference}</button>
                    </div>
                  </div>
                </div>
                `);

                sub_ul.append(sub_li);
                act_div.append(action_row);
            } else {
                // Es un invite
                invites[id]=name_print;
            }
        }
    });
    if(cont>0) {
        $('#activelines').html(sub_ul).show();
        $('#actions').html(act_div).show();
        $('#actions a[data-toggle="tooltip"]').tooltip();
        for(i=0;i<conferences.length;i++) {
             var conf_stage = activeCalls[conferences[i]].sessdata.confcalls[0].disposition;
             var conf_complete = activeCalls[conferences[i]].sessdata.confcalls[0].accept.complete;
             console.log('hide actions and show conference for line '+conferences[i]+" in stage "+conf_stage);
             if(conf_stage == 'progress') {
                 $('.conference_stage1').hide();
                 $('#btncajoinconf_'+conferences[i]).show();
                 $('#actionbuttons_'+conferences[i]).hide();
                 $('#conferencebox_'+conferences[i]).show();
             } else if(conf_stage=='accepted') {
                 $('.conference_stage1').hide();
                 $('.conference_stage2').show();
                 $('#conftarget_'+conferences[i]).hide();
                 $("#btnjoin_"+conferences[i]).show();
                 $("#btnfinishconf_"+conferences[i]).show();
                 $('#btncaconf_'+conferences[i]).hide();
                 $('#btncajoinconf_'+conferences[i]).hide();
                 $('#actionbuttons_'+conferences[i]).hide();
                 $('#conferencebox_'+conferences[i]).show();
             }
             if(conf_complete===true) {
                 $('#btnjoin_'+conferences[i]).hide();
             }

             // restore click events for conference stage buttons
             Object.keys(conf_handlers).forEach( id => { 
                 $(id).on(conf_handlers[id].type,conf_handlers[id].handler);
             });
        }
    } else {
        $('#activelines').html('').hide();
        $('#actions').html('').hide();
        parent.mypreferences.soundRing=''; // disable ring sound in FOP2
    }
    cont=0;
    invitehtml='';
    var sub_ul = $('<ul class="ulline">');
    Object.keys(invites).forEach( id => { 
       cont++;
       just_number = activeCalls[id].remoteIdentity.uri.raw.user;
       var sub_li = $('<li class="nosel inviteline attention2"><div class="display-flex"><div ><img class="contactimg" id="invitecontact_'+just_number+'" src="images/emptyprofile.jpg"></div><div style="width:100%;"><p><b>'+parent.lang['incoming_call']+'</b></p><p>'+invites[id]+'</p><p class="invitebuttons"><a class="btnanswer" id="answer_'+id+'" data-toggle="tooltip" title="'+parent.lang.answer+'"><span class="fa-stack fa"><i class="fa fa-circle fa-stack-2x text-success"></i><i class="fa fa-flip-horizontal fa-phone fa-stack-1x fa-inverse"></i></span></a> <a class="btnreject" id="reject_'+id+'" data-toggle="tooltip" title="'+parent.lang.reject+'"><span class="fa-stack fa"><i class="fa fa-circle fa-stack-2x text-danger"></i><i class="fa fa-phone fa-stack-1x fa-inverse" style="transform: rotate(225deg);"></i></span></a></p></div></div></li>');
       sub_ul.append(sub_li);
    });
    if(cont>0) {
        $('#invites').html(sub_ul).show();
        $('#invites a[data-toggle="tooltip"]').tooltip();
        $('#phoneicon').addClass('ringing3');
        if($('#teclado').hasClass('open-drawer')) {
            $('#teclado').removeClass('open-drawer');
        }
    } else {
        $('#invites').html('').hide();
        $('#phoneicon').removeClass('ringing3');
        
    }

    if(typeof(activeCalls[selectedLine])!='undefined') {
        part = [];
        part.push(activeCalls[selectedLine].remoteIdentity.uri.raw.user);
        part.push(activeCalls[selectedLine].remoteIdentity._displayName);
        name_print = part.join(' ');
        let verb='';
        if(activeCalls[selectedLine]._state == 'Establishing') {
            verb = parent.lang.trying;
            if(activeCalls[selectedLine].Inviter) {
                setFooterText(sprintf(parent.lang.trying_out_call_on_line,selectedLine));
            }
        } else if (activeCalls[selectedLine]._state == 'Established') {
            verb = parent.lang.talking;
            setFooterText(parent.lang['call_connected']);
        }

        if(activeCalls[selectedLine].isOnHold==true) {
            verb = parent.lang['held_call'];
        }
        if(conferences.indexOf(selectedLine+'')!==-1) {
            console.log("es una conferencia");
            var session = activeCalls[selectedLine];
            setStatusText(session.sessdata.confcalls[0].txtstatus);
        } else {
            if(verb!='') {
                $('#active_number').text(sprintf(verb,name_print));
            }
        }

        $('.actionrow').hide();
        $('#actn_'+selectedLine).show();


    } else {
        console.log("active calls de "+selectedLine+" esta sin definir");
        $('#active_number').html('&nbsp;');
    }

    $('.wrapperphone').scrollTop(0);
}

function setBLF(code,state) {
   code = code.replace(/\*/g, 'A');
   var color = '';
   if(state=='Ready')  {
      color = 'green';
   } else if(state=='On the phone') {
      color = 'red';
   } else if(state=='Unavailable') {
      color = 'grey';
   } else {
      color = 'pink';
   }
   if($('#'+code).length>0) {
       $('#'+code).css('color',color);
   }
}

function addBLF(code,name) {
   code = code.replace(/\*/g, 'A');
   if($('#blfelement_'+code).length==0) {
       var el = $(`<a id="blfelement_${code}" href="javascript:void(0);" data-toggle="tooltip" data-placement="right" title="${name}"><i class="fa fa-user-circle sidebaricon blf" id="${code}" aria-hidden="true"></i></a>`);
       $('#blf').append(el);
       $('#blfelement_'+code).tooltip();
   }
}

function renderRegister(state) {
    if(state == 'registered') {
        text = parent.lang.online;
        $('#regstate').css('color','#4dc54d').text(text);
        $('#phoneicon').css('color','#4dc54d');
    } else {
        text = parent.lang.offline;
        $('#regstate').css('color','#c54d4d').text(text);
        $('#phoneicon').css('color','#c54d4d');
    }
}

function pad2(number) {
   return (number < 10 ? '0' : '') + number;
}

function defaultFormat(x) {
    var x, seconds, minutes, hours;
    seconds = Math.floor(x % 60);
    x /= 60;
    minutes = Math.floor(x % 60);
    x /= 60;
    hours = Math.floor(x % 24);
    return [pad2(hours), pad2(minutes), pad2(seconds)].join(':');
}

function setStatusText(text) {
    $('#active_number').text(text);
}

function setFooterText(text) {
    $('.phonefooter').text(text);
}

function processKey(event) {

    if(registerer._state!='Registered') {
       console.log("not registered, ignores processKey");
       return;
    }

    if(parent.document.activeElement.id !='output') {
        // ignore keyup on input forms that are not named output
        var type = parent.document.activeElement.tagName;
        if(type=='INPUT' || type=='TEXTAREA') { return; }
    }

    try {
        var type = parent.document.scripterframe.document.activeElement.tagName;
        if(type=='INPUT') { return; }
    } catch(e) {}

    if(document.activeElement.id.indexOf('target')==0) {
        // its on the transfer input box, ignore
        return;
    }

    if(document.activeElement.id.indexOf('conftarget')==0) {
        // its on the conference input box, ignore
        return;
    }

    if ( event.which == 13 ) {
        event.preventDefault();
        if(document.activeElement.id=='chattransferto') {
            conversationid = $('#chat_transfer_conversation').data('conversationid');
            transferChat(conversationid,$('#chattransferto').val());
            $('#chattransferto').val(null).trigger('change');
        } else if(document.activeElement.id=='lbl_enteryourprivatenote') {
            if(!event.shiftKey) {
                $('#chatinputbox').submit();
                return;
            }
        } else if(document.activeElement.id=='lbl_enteryourmessage') {
            if(!event.shiftKey && !$('#emojis').is(':visible')) {
                // send chat on enter/return but allow new lines when shift+enter
                console.log("submit chatinputbox ("+$('#lbl_enteryourmessage').val()+")");
                $('#chatinputbox').submit();
                return;
            }
        } else if(document.activeElement.id=='historysearch') {
            getChatHistory().then(() => filterHistory());
        } else {
            output = $('#output').val();
            if(output!='') {
               dial(output);
               $('#output').val('');
               $('#output').blur();
               toggleBackspace();
               return;
            }
        }
    }

    if ( event.which == 186 && document.activeElement.id=='lbl_enteryourmessage') {
        if(word=='') {
            filter_emojis();
        }
        /*
        var curPos = document.getElementById("lbl_enteryourmessage").selectionStart;
        let x = $("#lbl_enteryourmessage").val();
        $("#lbl_enteryourmessage").val(x.slice(0, curPos-1) + x.slice(curPos)).selectRange(curPos-1);
        */
        return;
    }

    if(event.which ==56 && event.shiftKey ==true) {
        digit = '*';
        clicknum(digit);
    } else
    if(event.which ==51 && event.shiftKey ==true) {
        digit = '#';
        clicknum(digit);
    } else
    if(event.which >= 48 && event.which <= 57) {
        if($(document.activeElement).hasClass('emojibtn')) {
            // do nothing on emoji :search
        } else {
            digit = event.which-48;
            clicknum(digit+'');
        }
    } else if (event.which==8) {
        if(parent.document.activeElement.id != 'output') {
            current = $('#output').val();
            $('#output').val(current.slice(0,-1));
        }
    } else if (event.which==106) {
        clicknum('*');
    } else if (event.which==187) {
        clicknum('#');
    } else if (event.which==27) {
        $('#output').val('');
    }

    if(Object.keys(activeCalls).length==0) {
        toggleBackspace();
    }
}

function clicknum(num) {

    // dialpad dtmf click or keypress
    if(registerer._state!='Registered') {
       return;
    }

    var play_sound=0;

    if(Object.keys(activeCalls).length>0) {
        console.log(document.activeElement.id);
        if(document.activeElement.id != 'output') {
            play_sound=1;
            dtmf(selectedLine,num);
        }
    } else {
        // no active calls, append clicked number to dial input
        console.log(document.activeElement.id);
        if( document.activeElement.id != 'output' && document.activeElement.id != 'lbl_enteryourmessage' && 
            document.activeElement.id != 'contact_filter' && document.activeElement.id != 'chattransferto' && document.activeElement.id != 'emojisearch' && document.activeElement.id != 'historysearch' && document.activeElement.id != 'lbl_enteryourprivatenote') {
            current = $('#output').val();
            $('#output').val(current+''+num);
        }
        if(document.activeElement.id != 'lbl_enteryourmessage' && document.activeElement.id != 'contact_filter' && document.activeElement.id != 'chattransferto' && document.activeElement.id != 'emojisearch' && document.activeElement.id != 'historysearch' && document.activeElement.id != 'lbl_enteryourprivatenote') {
            play_sound=1;
            dtmf(0,num);
        }
    }
    toggleBackspace();
    if(play_sound==1) {
        el = document.getElementById('dtmf_'+num);
        el.setSinkId(getSpeakerDevice());
        el.play().catch(function() { console.log('error playing audio');});
    }
}

function toggleBackspace() {
    if($('#output').val()=='') {
        $('#backspace').hide();
        $('#dialbutton').hide();
    } else {
        $('#backspace').show();
        $('#dialbutton').show();
    }
}

function setOutput(text) {
    $('#output').text(text);
}

function setText() {
    $('#soundinput').html(parent.lang['sound_input']);
    $('#soundoutput').html(parent.lang['sound_output']);
    $('#ringer').html(parent.lang.ringer);
    $('.showdialpad').attr('data-original-title',parent.lang.dialpad);
    $('.showaudiosettings').attr('data-original-title',parent.lang.audio_settings);
    $('.showmwi').attr('data-original-title',parent.lang.voicemail);
    $('#lbl_noise_suppresion').html(parent.lang['noise_suppresion']);
    $('#lbl_echo_cancellation').html(parent.lang['echo_cancellation']);
    $('#lbl_auto_gain_control').html(parent.lang['auto_gain_control']);
    $('#lbl_autoanswer').text(parent.lang.autoanswer);
    $('.emojisearchplaceholder').attr('placeholder',parent.lang.searchemoji);
    $('#lbl_enteryourmessage').attr('placeholder',parent.lang.enteryourmessage);
    $('#lbl_enteryourprivatenote').attr('placeholder',parent.lang.enteryourprivatenote);
    $('#historysearch').attr('placeholder',parent.lang.search);
    $('#contact_filter').attr('placeholder',parent.lang.searchcontact);
    $('#lbl_intercom').text(parent.lang.intercommode);
    $('#lbl_callwaiting').text(parent.lang.callwaiting);
    $('.showpreferences').attr('data-original-title',parent.lang.settings);
    $('#lbl_preferences').html(parent.lang.settings);
    $('#lbl_audiosettings').html(parent.lang.audio_settings);
    $('#lbl_ringtone').html(parent.lang.ringtone);
    $('#phonerestart').html(parent.lang.phonerestart);
    $('#chatqueuetitle').html(parent.lang.pendingchats);
    $('#dialbutton').attr('data-original-title',parent.lang.dial);
    $('#dndbadge').attr('data-original-title',parent.lang.donotdisturb);
    $('#qloginbadge').attr('data-original-title',parent.lang.lbllogin);
    $('#lbl_recent').html(parent.lang['recent']);
    $('#menu_add_contact').html(parent.lang['addcontact']);
    $('#menu_view_contact').html(parent.lang['viewcontact']);
    $('#menu_tag_notes').html(parent.lang['menu_tag_notes']);
    $('#menu_chat_history').html(parent.lang['menu_chat_history']);
    $('.chathistory').attr('data-original-title',parent.lang['menu_chat_history']);
    $('#chat_audiocall').attr('data-original-title',parent.lang['chat_audiocall']);
    $('#history_close').attr('data-original-title',parent.lang['close']);
    $('#chat_clear').attr('data-original-title',parent.lang['chat_clear_conversation']);
    $('#call_spy').attr('data-original-title',parent.lang['spy']);
    $('#chat_close_conversation').attr('data-original-title',parent.lang['chat_close_conversation']);
    $('#chat_transfer_conversation').attr('data-original-title',parent.lang['chat_transfer_conversation']);
    $('.chatmonitor').attr('data-original-title',parent.lang['chatmonitor']);
    if(queuelogincode==null || queuelogincode=='') {
        $('#qloginbadge').hide();
    }
    if(dndcode==null || dndcode=='') {
        $('#dndbadge').hide();
    }
    $('#lbl_attach_document').html(parent.lang.document);
    $('#lbl_attach_image').html(parent.lang.image);
    $('#lbl_attach_sticker').html(parent.lang.sticker);
    $('#action_call_spy').html(parent.lang['spy']);
    $('#action_call_whisper').html(parent.lang['whisper']);
    $('#action_call_barge').html(parent.lang['barge']);
}

function hideShowMwi(action) {
    if($('#teclado').hasClass('open-drawer')) {
        $('.showmwi').hide();
    } else {
        if(parent.plugins['phonepro'].hasVoicemail()==1) {
            $('.showmwi').show();
        }
    }
    return;
}

function enablePhoneActionButtons(line_no) {
   console.log('re enabling action buttons on line '+line_no);
   $('.requireconnect'+line_no).each(function() {
      $(this).attr('data-disabled',false).removeClass('disabled');
   });
}

function disablePhoneActionButtons(line_no) {
   console.log('disabling action buttons on line '+line_no);
   $('.requireconnect'+line_no).each(function() {
      $(this).attr('data-disabled',true).addClass('disabled');

   });
}

function get(selector, root = document) {
    return root.querySelector(selector);
}

function formatDate(date) {
    const h = "0" + date.getHours();
    const m = "0" + date.getMinutes();
    return `${h.slice(-2)}:${m.slice(-2)}`;
}

function mime_icon(extension) {
    if(extension=='pdf') {
        return 'far fa-2x fa-file-pdf';
    } else if(extension=='xls') {
        return 'far fa-2x fa-file-excel';
    } else if(extension=='doc' || extension=='docx') {
        return 'far fa-2x fa-file-word';
    } else if(extension=='zip' || extension=='gz' || extension=='tgz' || extension=='rar') {
        return 'fas fa-2x fa-file-archive';
    } else {
        return 'far fa-2x fa-file';
    }
}

function extractWaidNumber(input) {
  const match = input.match(/waid=(\d+)/);
  if (match) {
    return match[1];
  } else {
    return null;
  }
}

function appendMessage(exten, msgid, name, img, side, text, dateStr, icon, conversationid, tohistory, tag, attachment, channel, nocounter=0, did='') {
    // print Message In 
    //
    if(typeof(channel)=='undefined') {
        channel='internal';
    }
    did = did.toString().replace(/[^A-Za-z0-9_]/g, "");
    if(did.indexOf('internal')==0) {
        did='internal';
    }
    exten = String(exten);
    console.log("appendMessage exten="+exten+", msgid="+msgid+",name="+name+",img="+img+",side="+side+",text="+text+",dateStr="+dateStr+",icon="+icon+",conversationid="+conversationid+",tohistory="+tohistory+",tag="+tag+",attachment="+attachment+",channel="+channel+",nocounter="+nocounter+",did="+did);
    text = sanitizeMessage(text,side);
    var sentState = "msgunknown";

    var divattach='';
    if(typeof(attachment)!='undefined' && attachment.length>0) {
        var allfiles = [];
        queuemsgid = attachment.shift();
        baseurl = "/realtime/api/files/messages/"+queuemsgid;
        console.log(baseurl);
        allfiles = attachment[0].map(file => baseurl+"/"+file);
        for(let i=0;i<allfiles.length;i++) {
            let extension = allfiles[i].split(".").pop();
            console.log(extension);
            parts_filename = allfiles[i].split("/").pop().split("_");
            parts_filename.pop();
            filename = parts_filename.join("_")+"."+extension;
            console.log(filename);

            if(extension=='gif' || extension=='jpeg' || extension=='webp' || extension=='png' || extension=='jpg') {
                mywidth=300;
                if(extension=='webp') {
                   mywidth=190;
                }
                divattach+='<div class="mb-10"><a download="'+filename+'" href="'+allfiles[i]+'" style="display:block;"><img style="max-width:'+mywidth+'px; cursor:pointer;" src="'+allfiles[i]+'?thumb='+mywidth+'x0"></a></div>';
            } else if(extension=='mp4') {
                divattach+='<div class="mb-10"><video width="400" controls><source src="'+allfiles[i]+'"></video></div>';
            } else if(extension.substr(0,2)=='og') {
                    divattach+='<audio controls src="'+allfiles[i]+'"> <a href="'+allfiles[i]+'">Download audio</a></audio>';
            } else if(extension=='vcf') {
                    var parts = allfiles[i].split("/");
                    var filename = parts.pop();
                    var msgid = parts.pop();
                    divattach+='<div style="display:flex;flex-direction:row;align-items:center;border:1px solid #ddd;border-radius:5px;padding:5px;background-color:#fff;">';
                    divattach+='<div><img style="width:50px;" class="img-responsive img-circle avatar hidden" id="img_'+msgid+'"></div>';
                    divattach+='<div style="padding:0 10px;"><strong>'+text+'</strong></div>';
                    divattach+='</div>';
                    divattach+='<button type="button" onclick="importContact(\''+parent.Base64.encode(allfiles[i])+'\',\'img_'+msgid+'\')" class="btn btn-sm btn-default">'+parent.lang.addcontact+'</button>';
                    text ='';
                    // api.php
                    fetch(allfiles[i]).then((response)=>response.text()).then((response)=>{
                        number = extractWaidNumber(response);
                        console.log("get avatar for "+number);
                        fetch('../menu/api.php?action=getAvatar&channel='+channel+'&user='+number).then((response)=>response.json()).then((avdata)=> {
                            console.log("tengo avatar "+avdata.avatar+" para el id img_"+msgid);
                            $('#img_'+msgid).attr('src',avdata.avatar).removeClass('hidden');

                        })
                    });
            } else {
                mime = mime_icon(extension);
                divattach+='<div class="mb-10"><a href="'+allfiles[i]+'" download="'+filename+'"><i class="'+mime+'"></i> '+filename+'</a></div>';
            }
        }
    }

    tstamp = new Date();
    if(typeof(dateStr)!='undefined') {
        year   = dateStr.substr(0,4);
        month  = parseInt(dateStr.substr(5,2))-1;
        day    = dateStr.substr(8,2);
        hour   = dateStr.substr(11,2);
        minute = dateStr.substr(14,2);
        second = dateStr.substr(17,2);
        tstamp = new Date(year,month,day,hour,minute,second);
        sentState = "msgok";
    }

    if(tohistory==1 || tohistory==2) {
        sentState = "msgok";
    }

    var phonenumber=exten;
    console.log("1 nico phonenumber "+phonenumber);
    if(phonenumber!='chatbroker') {
        phonenumber = phonenumber.replace(/\D+$/g,'');
    }
    console.log("2 nico phonenumber "+phonenumber);

    if(exten!='chatbroker') {
        exten = exten.replace(/\D/g,'');
    }

console.log("existe #contact_"+channel+'_'+exten+'_'+did);
console.log("existe #contact_"+channel+'_'+exten+'_'+did);

    let checkdid = did
    if(channel=='internal') { checkdid='internal'; }

    if(document.getElementById('contact_'+channel+'_'+exten+'_'+checkdid)===null && (tohistory===undefined || tohistory==0) && (side == 'right' || side=='left' || side == 'autoreply' || side == 'broadcast' || side == 'note' || side =='info')) {
        // Create contact
        console.log("create contact! exten="+exten+", name="+name+", icon="+icon+", conversationid="+conversationid+", tag="+tag+", channel="+channel+", did="+did+", phonenumber="+phonenumber);
        createContact(exten,name,icon,conversationid,tag,channel,did,phonenumber);
    }

    if(side=='autoreply') { 
      name='Bot'; 
      side='right'; 
      img = 'https://avatars.dicebear.com/api/bottts/your-asdf4.svg';
    }

    var unreadclass='';
    if(tohistory===undefined || tohistory==0) {

        // borrow chat notification sounds from parent
        if(side=='left') {
            if (parent.mypreferences.soundChat !== "") {
                if($('#chat_'+channel+'_'+exten+'_'+did).is(':visible')==false) {
                    parent.sonido['blip'].play();
                } else {
                    parent.sonido['newchat'].play();
                }
            }
        }

        if(nocounter==0) {
            if($('#chat_'+channel+'_'+exten+'_'+did).is(':visible')==false && side=='left') {
                unreadclass='unread';
                var howmanyunread = $('#chat_'+channel+'_'+exten+'_'+did+' .unread').length + 1;
                $('#msgcount_'+channel+'_'+exten+'_'+did).text(howmanyunread);
            }
        }
    }

    broadcast_name = '';
    if(side=='broadcast') {
       broadcast_name = img;
    }

    console.log("side "+side+" img "+img);

    if(tohistory==3 && img.substring(0,1)=='.') {
       // called from fop2 manager, relative path changes
       img = img.substring(9);
       console.log('nico '+img);
    }

    if(img=='') {
        seed = name.replace(/[\u{0080}-\u{FFFF} ]/gu,"");
        if(avatar_url.substring(0,4)=='http') {
            if(avatar_url.indexOf('api.dicebear.com')>-1) {
                const separator = avatar_url.includes('?') ? '&' : '?';
                img = avatar_url+separator+'seed='+seed;
                if(side=='right') { img = img + '&flip=true'; }
            }
        } else {
            img = '../menu/api.php?action=boringavatar&seed='+seed;
        }
    }

    const msgHTML = `
      <div class="msg ${side}-msg ${unreadclass}">
        ${side == 'note' || side =='broadcast' || side =='info'?'':`<div class="msg-img avatar-img-${msgid}" style="background-image: url(${img})"></div>`}

        ${side == 'note' || side =='broadcast' || side=='info'?`<div class="msg-${side=='info'?'flow':`${side}`}">`:'<div class="msg-bubble">'}
          <div class="msg-info">
            ${side != 'broadcast'?`<div class="msg-info-name">${side =='info'?`<span data-trans="${text}">${text}</span>`:`${name}`}</div>`:`<div class="msg-info-name"><i class="fas fa-bullhorn"></i> Broadcast ${broadcast_name}</div>`}
            ${side != 'broadcast'?'<div class="msg-info-time">'+formatDate(tstamp)+'</div>':''}
            <div class="msg-sent" id="msg_${msgid}">
            ${side == 'right'?`<i class="fa fa-check ${sentState} ml-10"></i>`:''}
            </div>
          </div>
          ${side == 'info'?``:`
          ${divattach}
          <div class="msg-text">${text}</div>
          `}
        </div>
      </div>
    `;

    if(tohistory===undefined || tohistory==0) {

        var ele = document.getElementById('chat_'+channel+'_'+exten+'_'+checkdid);
        ele.insertAdjacentHTML("beforeend", msgHTML);
//        $('#chat_'+channel+'_'+exten+'_'+checkdid).get(0).insertAdjacentHTML("beforeend", msgHTML);

        $('#msger-chat').scrollTop($('#msger-chat')[0].scrollHeight);
        if(channel!='internal') {
            $('#contact_'+channel+'_'+exten+'_'+did).insertBefore($('.extencontact').first());
        }
    } else if(tohistory==1 || tohistory==3) {
        $('#chathistory_main').get(0).insertAdjacentHTML("beforeend", msgHTML);
    } else if(tohistory==2) {
        $('#chatmonitor_main').get(0).insertAdjacentHTML("beforeend", msgHTML);
    }
}

function uuidv4() {
  return ([1e7]+-1e3+-4e3+-8e3+-1e11).replace(/[018]/g, c =>
    (c ^ crypto.getRandomValues(new Uint8Array(1))[0] & 15 >> c / 4).toString(16)
  );
}

async function sendPrivateNote(body) {
    $('.msger-whisper').val('');
    var conversation = $('#chatmonitor_main').data('currentconversation');
    var from = parent.myextension;
    var name = parent.botonitos[parent.myposition]['LABEL'];
    var direction = "note";

    const record = await pocketclient.collection('messages').create({
        body: body,
        conversation: conversation,
        from: from,
        name: name,
        avatar: '',
        direction: 'note'
    });
}

async function printMessageOut(exten,msgText,msgid) {
    console.log("start printMessageOut exten="+exten+", text="+msgText+",msgid="+msgid);
    avatar = await getLocalAvatar(parent.myextension);
    $('.msger-input').val('');
    //channel = selectedContact.split('_').slice(0, -2).join('_');
    var channel = $('#contact_'+selectedContact).data('channel');
    var tag = $('#contact_'+selectedContact).data('tag');
    var did = $('#contact_'+selectedContact).data('did');
    var msgdata = await uploadAttachMessage(msgText,avatar,exten);
    queuemsgid = msgdata[0];
    attachments = msgdata[1];

    console.log("printMessageOut exten="+exten+",msgText="+msgText+",msgid="+msgid+",avatar="+avatar+",queue message id:"+queuemsgid+", did:"+did);

    console.log("attachments: ");
    console.log(attachments);

    $('.dz-preview').remove();
    if(tag!='openchannel') {
        appendMessage(exten, msgid, PERSON_NAME, avatar, "right", msgText, undefined, undefined, undefined, undefined, '', [queuemsgid,attachments], channel, 0, did);
    }
    return queuemsgid; // return the id for pocketbase msg entry in order to retrieve attachs when sening out provider
}

function markMessageFail(msgid) {
    setTimeout(function() { $('#msg_'+msgid).html('<i class="fa fa-check msgfail ml-10"></i>'); }, 2000);
}

function markMessageOk(msgid) {
    setTimeout(function() { $('#msg_'+msgid).html('<i class="fa fa-check msgok ml-10"></i>'); }, 2000);
}

function relateMessageToTag(msgid,tag) {
    $('#msg_'+msgid).attr('data-tag',tag);
}

function addTags(exten,tags) {
    if(tags!='undefined') {
        $('#contact_internal_'+exten+'_internal').data('tags',tags);
    }
}

function createContact(exten,contactname,icon,conversationid,tag,channel,did,phonenumber) {
    console.log("nico createcontact exten="+exten+",name="+contactname+",icon="+icon+",conversationid="+conversationid+",tag="+tag+",channel="+channel+",did="+did+",phonenumber="+phonenumber);
    console.log('dentro de create contact rrr con did '+did);
    provider_capabilities['internal_'+did]='full'; 
    provider_audiocall['internal_'+did]='1';

    idx_prov = channel+'_'+did;

    var encodedname = parent.Base64.encode(contactname);
    //if(channel=='webchat') {
        $('#contacts').append(`<div class="wp-panel extencontact" id="contact_${channel}_${exten}_${did}" ${channel !== undefined?' data-channel="'+channel+'"':''} data-tag="${tag}" data-name="${encodedname}" data-audiocall="${provider_audiocall[idx_prov]}" data-contact="${channel}_${exten}_${did}" ${icon !== undefined?' data-fromqueue="yes" ':''} ${conversationid !== undefined?' data-conversationid="'+conversationid+'"':''} data-capabilities="${provider_capabilities[idx_prov]}" data-ptt="${provider_ptt[idx_prov]}" data-did="${did}" data-phonenumber="${phonenumber}"> 
        ${icon !== undefined?'<img class="channel-img" src="'+icon+'"/>':''}
        <div>${contactname}</div><div class="msgcountbadge"><span class="badge" id="msgcount_${channel}_${exten}_${did}"></span></div></div>`);
    //} else {
    //    $('#contacts').append(`<div class="wp-panel extencontact" id="contact_${channel}_${exten}" ${channel !== undefined?' data-channel="'+channel+'"':''} data-tag="${tag}" data-name="${encodedname}" data-audiocall="${provider_audiocall[idx_prov]}" data-contact="${channel}_${exten}" ${icon !== undefined?' data-fromqueue="yes" ':''} ${conversationid !== undefined?' data-conversationid="'+conversationid+'"':''} data-capabilities="${provider_capabilities[idx_prov]}" data-ptt="${provider_ptt[idx_prov]}" data-did="${did}" data-phonenumber="${phonenumber}"> 
    //    ${icon !== undefined?'<img class="channel-img" src="'+icon+'"/>':''}
    //    <div>${contactname}</div><div class="msgcountbadge"><span class="badge" id="msgcount_${channel}_${exten}"></span></div></div>`);
    //}

    if(icon!==undefined)  {
        $('#msger-chat').append('<div id="chathistory_'+exten+'" style="display:none;" class="contacthistory"></div>');
    } else {
        console.log("icon not defined, do not create chathistory");
    }

    $('#msger-chat').append('<div id="chat_'+channel+'_'+exten+'_'+did+'" style="display:none;" class="contactchat"></div>');

    console.log('chat_'+channel+'_'+exten+'_'+did);
    console.log('chat_'+channel+'_'+exten+'_'+did);
    if(channel!='internal') {
      // TODO metadata table
      //var metaelement = $('#chat_'+channel+'_'+exten+'_'+did);
      var metaelement = document.getElementById('chat_'+channel+'_'+exten+'_'+did);
      console.log(metaelement);
      var metaprefix  = exten;
      var showend     = 'hidden';
      var showagent   = 'hidden';
      var updatestart = 'timeago';
      metadataTable(conversationid,metaelement,metaprefix,showend,showagent,updatestart,0);


    }
  
}

function filteremoji(e) {
    var regex = new RegExp("\\b\\w*" + e + "\\w*\\b");
    $("#all span")
      .hide()
      .filter(function () {
          return regex.test($(this).data("keywords"));
      })
      .show();
}

function isEmojiOnly(str) {
  const stringToTest = str.replace(/ /g,'');
  const emojiRegex = /^(?:(?:\p{RI}\p{RI}|\p{Emoji}(?:\p{Emoji_Modifier}|\u{FE0F}\u{20E3}?|[\u{E0020}-\u{E007E}]+\u{E007F})?(?:\u{200D}\p{Emoji}(?:\p{Emoji_Modifier}|\u{FE0F}\u{20E3}?|[\u{E0020}-\u{E007E}]+\u{E007F})?)*)|[\u{1f900}-\u{1f9ff}\u{2600}-\u{26ff}\u{2700}-\u{27bf}])+$/u;
  return emojiRegex.test(stringToTest) && Number.isNaN(Number(stringToTest));
}

function sanitizeMessage(text,side) {
    text = escapeTags(text);
    // only do click2call on numbers for received messages
    text = replaceFixedfont(text);
    if(side=='left') {
        text = replaceNumber(text);
    }
    text = replaceURL(text);
    text = addQuote(text);
    text = addBR(text);
    text = enlargeEMOJI(text);
    return text;
}

//    text = text.replace(/(?:\r\n|\r|\n)/igm, '<br>');
//    text = text.replace(/\n(?![^<]*<\/pre>)/igm, 'gato<br>');

function enlargeEMOJI(text) {
    if(isEmojiOnly(text)) {
        return "<span class='bigemoji'>"+text+"</span>";
    } else {
        return text;
    }
}

function addBR(text) {
    text = text.replace(/\n(?=((?!<\/pre).)*?(<pre|$))/sg, '<br>');
    return text;
}

function replaceFixedfont(text) {
    var exp = /```([^\`\`\`]*)```/ig;
    return text.replace(exp, "<pre>$1</pre>");
}

function replaceNumber(text) {
    var exp = /(\b(?<!\d )(?=(?:\d[ -]?){8,19}(?![ -]?\d))(?:\d{1,}[ -]?)+\b(?! ?\d))/ig;
    return text.replace(exp, "<a href='javascript:void(0);' onclick='dial(\"$1\");'>$1</a>");
}

function addQuote(text) {
    var exp = /^"([^"]*)"(.*)$/;
    return text.replace(exp, "<div class='blockquote'>$1</div>$2");
}

function replaceURL(text) {
    // Used in CHAT to create a link when an url is posted
    var exp = /((?:(?:https?|ftp|file):\/\/|www\.|ftp\.)(?:\([-A-Z0-9+&@#/%=~_|$?!:,.]*\)|[-A-Z0-9+&@#/%=~_|$?!:,.])*(?:\([-A-Z0-9+&@#/%=~_|$?!:,.]*\)|[A-Z0-9+&@#/%=~_|$]))/ig;
    var re = new RegExp(exp);
    var m = re.exec(text);
    var ret = '';
    if (m !== null) {
        if (m[2] === undefined) {
            ret = "http://";
        }
    }
    return text.replace(exp, "<a href='" + ret + "$1' target='_blank'>$1</a>");
}

function escapeTags(s) {
    var escape = document.createElement('textarea');
    escape.textContent = s;
    ret = escape.innerHTML;
    delete(escape);
    return ret;
}

function createBLF(exten) {
    blf[exten]='Extension';
}

function filterContact(e) {
  if(e!='') {
      $('.extencontact').hide();

      var regex = new RegExp("\\b\\w*" + e + "\\w*\\b",'i');
      $(".extencontact")
        .filter(function () {
          return regex.test($(this).text()) || regex.test($(this).data('tags'));
        })
        .show();
  } else {
      $('.extencontact').show();
  }
}

/* Adds a new conversation into pending chats widget */
function addToChatQueue(id,data) {

    if($('#'+id).length>0) {
        // Already exists, leave it alone
        return;
    }

    mydata  = JSON.parse(data);

    console.log("ADD_TO_CHAT_QUEUE: Add new conversation into pending chats queue");

    console.log(mydata);

    sender  = mydata.sender;
    chatid  = mydata.chatid;
    did     = mydata.did;
    dateStr = mydata.created;
    year    = dateStr.substr(0,4);
    month   = parseInt(dateStr.substr(5,2))-1;
    day     = dateStr.substr(8,2);
    hour    = dateStr.substr(11,2);
    minute  = dateStr.substr(14,2);
    second  = dateStr.substr(17,2);

    grpindex = mydata.channel+'_'+mydata.did;
    console.log("grpindex "+grpindex);

/*
    if(mydata.transferer=='' && mydata.route=='') {
        // Restrict new chat from showing based on "general" service groups only if its NOT a transfer
        // (transfers can bypass service group restrictions)
        if(typeof(service_groups[provider_group[grpindex]])!='undefined') {
            if(!service_groups[provider_group[grpindex]].includes(parent.myextension)) {
                // Do not show, is not member of the service group
                return;
            }
        } else {
            console.log("ADD_TO_CHAT_QUEUE: No service_groups defined for "+provider_group[grpindex]);
        }
    }
*/

    if(mydata.transferer.split(' ')[0]==parent.myextension) { return; } // Do not show to the extension transferring

    if(mydata.transferer=='' && mydata.route=='') {
        // Restrict new chat from showing based on "general" service groups only if its NOT a transfer
        // (transfers can bypass service group restrictions)

        if(mydata.servicegroup!='All Extensions' && mydata.servicegroup!='') {
            if(typeof(service_groups[mydata.servicegroup])!='undefined') {
                if(!service_groups[mydata.servicegroup].includes(parent.myextension)) {
                    // Do not show, is not member of the service group
                    return;
                }
            }
        } else {
            console.log("ADD_TO_CHAT_QUEUE: No service_groups defined for "+mydata.servicegroup);
        }
    }

    if(mydata.route!='' && mydata.transferer!='') {


        // it was transferred to a service group, restrict only to service group
        if(typeof(service_groups[mydata.route])!='undefined') {
            if(!service_groups[mydata.route].includes(parent.myextension)) {
                // Do not show, is not member of the service group
                return;
            }
        }
    }

    if(mydata.route!='' && mydata.transferer=='') {
        if(mydata.route.indexOf('self')==0) {
            to_whom = mydata.route.split('-')[1];
            console.log("only to "+to_whom);
            if(to_whom!=parent.myextension) {
                return;
            }
        } else {
            if(!service_groups[mydata.route].includes(parent.myextension)) {
                return;
            }
        }
    }

    if(mydata.assignedto!='' && mydata.assignedto!=parent.myextension) {
        // If new chat has assignedto, is an outbound message, display it ONLY to the agent that originated the chat
        return;
    }

    /* all restriction checks passed, add the call to pending chats */

    const date   = new Date(year,month,day,hour,minute,second);
    const tstamp = Math.floor(date.getTime()/1000);
    var now      = new Date;
    var timezone = now.getTimezoneOffset();
    tstamp2      = tstamp - (timezone*60);
    var icon     = mydata.icon;
    var channel  = mydata.channel;
    var avatar   = mydata.avatar;
    var body     = '&nbsp;';
    var transfer = mydata.transferer;

    if(avatar=='') {
        seed = sender.replace(/[\u{0080}-\u{FFFF} ]/gu,"");
        if(avatar_url.substring(0,4)=='http') {
            const separator = avatar_url.includes('?') ? '&' : '?';
            avatar = avatar_url+separator+'seed='+seed;
        } else {
            //avatar = 'https://api.dicebear.com/6.x/personas/svg?facialHairProbability=0&seed='+seed;
            avatar = '../menu/api.php?action=boringavatar&seed='+seed;
        }
        console.log("ADD_TO_CHAT_QUEUE: No avatar provider. Use dicebear generated avatars for sender "+sender+" seed "+seed+" avatar="+avatar);
        localstorageCacheSet("avatar_"+sender,avatar,86400);
    }
 
    console.log("ADD_TO_CHAT_QUEUE: Add to invite widget id="+id+", sender="+sender+", icon="+icon+", chatid="+chatid+", avatar="+avatar);

    chatbgcolor='';
    if(transfer!='') {
       chatbgcolor='istransfer';
    }

    // Check if we have a CRM defined for popups, to popuplate it in data-crm 
    var crm = '';
    if(provider_crm[grpindex]!='') {
        crm = provider_crm[grpindex];
    }
    /*
    var act_div = `<div id="${id}" class='pendingchat-panel ${chatbgcolor}'>
     <div id='color_${id}' style="position:absolute;top:0;left:0;bottom:0;width:10px; background-color: #f3f3f3;border-radius:5px 0 0 5px;"></div>
     <div style='display:flex; align-items:center; margin-left:5px;'>
     <div class='avataricon'>
     ${avatar !== undefined?'<img class="channel-img" src="'+avatar+'"/>':''}
     </div>
     <div class='chatfrom'>
     ${sender}
     </div>
     </div>
     <div class="pendingmsg" id="pendingmsg_${id}" style='margin-left:5px;'>${body}</div>
     <div style='display:flex; align-items:center; margin-left:5px;'>
     <div class='chataccept btn btn-xs btn-success' data-crm='${crm}' data-channel='${channel}' data-icon='${icon}' data-conversationid='${id}' id='acceptchat_${id}'>${parent.lang.accept}</div>
     <div class='channelicon'>
     ${icon !== undefined?'<img class="channel-img" src="'+icon+'"/>':''}
     </div>
     ${transfer!=''?'<div data-toggle="tooltip" title="'+transfer+'"><span style="zoom:.8;" class="fa-stack"><i class="far fa-circle fa-stack-2x"></i><i class="fas fa-exchange-alt fa-stack-1x"></i></span></div>':''}
     <div class="timerchat" id="timerchat_${id}" data-starttime="${tstamp2}"></div>
     </div>
     </div>`;
    */
    didsanity = did.replace(/[^A-Za-z0-9_]/g, "");
    var prov_name = provider_name[channel+'_'+didsanity];

    var act_div = `<div id="${id}" class='pendingchat-panel ${chatbgcolor}'>
     <div id='color_${id}' style="position:absolute;top:0;left:0;bottom:0;width:10px; background-color: #f3f3f3;border-radius:5px 0 0 5px;"></div>
     <div style='display:flex; align-items:stretch; margin-left:5px;'>
     <div class='avataricon'>
     ${avatar !== undefined?`<img class="pending-avatar-img" src="${avatar}"/>`:''}
     </div>
     <div style="width: calc(100% - 3em)">
     <div class='chatfrom'>
     ${sender}
     </div>
     <div class="pendingmsg" id="pendingmsg_${id}">${body}</div>
     <div style='display:flex; align-items:center;'>
     <div class='chataccept btn btn-xs btn-success' data-crm='${crm}' data-channel='${channel}' data-icon='${icon}' data-conversationid='${id}' id='acceptchat_${id}'>${parent.lang.accept}</div>
     <div class='channelicon'>
     ${icon !== undefined?`<img class="channel-img" data-toggle="tooltip" title="${prov_name}" src="${icon}"/>`:''}
     </div>
     ${transfer!=''?`<div data-toggle="tooltip" title="${transfer}"><span style="zoom:.7;" class="fa-stack"><i class="far fa-circle fa-stack-2x"></i><i class="fas fa-exchange-alt fa-stack-1x"></i></span></div>`:''}
     <div class="timerchat" id="timerchat_${id}" data-starttime="${tstamp2}"></div>
     </div>
     </div>
     </div>
     </div>`;

    var act_div = `<div id="${id}" class='pendingchat-panel ${chatbgcolor}'>
     <div id='color_${id}' style="position:absolute;top:0;left:0;bottom:0;width:10px; background-color: #f3f3f3;border-radius:5px 0 0 5px;"></div>

     <div style='display:flex; align-items:stretch; margin-left:5px;'>
     <div class='avataricon'>
     ${avatar !== undefined?`<img class="pending-avatar-img" src="${avatar}"/>`:''}
     </div>
     <div style="width: calc(100% - 3em)">
     <div class='chatfrom'>
     ${sender}
     </div>
     <div class="pendingmsg" id="pendingmsg_${id}">${body}</div>
     </div>

     </div>
     <div style='padding-left:5px;'>
       <div style='display:flex; align-items:center;'>
         <div class='chataccept btn btn-xs btn-success' data-crm='${crm}' data-channel='${channel}' data-icon='${icon}' data-conversationid='${id}' id='acceptchat_${id}'>${parent.lang.accept}</div>
         <div class='channelicon'>
           ${icon !== undefined?`<img class="channel-img" data-toggle="tooltip" title="${prov_name}" src="${icon}"/>`:''}
         </div>
          ${transfer!=''?`<div data-toggle="tooltip" title="${transfer}"><span style="zoom:.7;" class="fa-stack"><i class="far fa-circle fa-stack-2x"></i><i class="fas fa-exchange-alt fa-stack-1x"></i></span></div>`:''}
         <div class="timerchat" id="timerchat_${id}" data-starttime="${tstamp2}"></div>
       </div>
     </div>

     </div>
     </div>`;


    if(mydata.state=='open') {

        $('#chatqueue').prepend(act_div);
        $('#pendingchats').show();
        $('#chatqueue').find('[data-toggle="tooltip"]').tooltip();

        var sound = new Howl({
            src: ['sounds/dingdong.mp3'],
            autoplay: true,
            loop: false,
            volume: 0.5
        });

        firstname=mydata.sender.split(" ")[0];
        lastname=mydata.sender.split(" ")[1];
        console.log('ADD_TO_CHAT_QUEUE: check if contact exists '+mydata.phonenumber+","+firstname+" "+lastname+", channel: "+channel);
        doesContactExists(mydata.phonenumber,firstname,lastname,channel).then((data)=> {
            jsondata = JSON.parse(data);
            if(jsondata.id>=0) {
                actual_color = jsondata.color;
                console.log("ADD_TO_CHAT_QUEUE: found contact!");
            } else {
                actual_color = '';
                console.log("ADD_TO_CHAT_QUEUE: contact not found!");
            }
            if(actual_color!='') {
                console.log("ADD_TO_CHAT_QUEUE: set contact color to "+actual_color);
                $('#color_'+id).css('background-color',actual_color);
            }

        });

    } else {
        console.log("add to queue was not state open, do not play sound nor check tag color, lets do auto accept. used for message origination");
        acceptChat(parent.myextension,icon,id,channel,crm);
    }

}

async function transferChat(id,exten) {
    if(exten===null) return;
    console.log('transfer chat id '+id+' to exten '+exten);
    transferer = parent.botonitos[parent.myposition].EXTENSION+" "+parent.botonitos[parent.myposition].LABEL;

    if(exten.substr(0,1)=='[') {
        // Transfer to service group
        route = exten.substr(1,exten.length-2);
        exten = 'ALL';
        bot_url = '';
        state = 'open';
    } else if(exten.substr(0,1)=='{') {
        // Transfer to bot
        bot_url = exten.substr(1,exten.length-2);
        route = '';
        exten = 'ALL';
        state = 'bot';
        transferer = '';
    } else {
        state = 'open';
        bot_url = '';
        route = '';
    }

    if(validTransfer.includes(exten)) {
        if(exten=='ALL') { exten=''; }

         console.log('route '+route);
         console.log('exten '+exten);
         console.log('state '+state);
         console.log('bot_url '+bot_url);

        const record = await pocketclient.collection('incomingqueue').update(id, {
            state: state,
            bot_url: bot_url,
            assignedto: exten,
            transferer: transferer,
            route: route,
            bot_state: ''
        }).then((data)=> { 
            // crear un mensaje info de transferencia
            const mrecord = pocketclient.collection('messages').create({
                body: parent.lang.chat_transferred,
                conversation: data.id,
                from: 'system',
                name: data.sender,
                avatar: data.avatar,
                direction: 'info'
            });
            if(state=='bot') {
                // forward to bot via api.php and hope for the best
                fetch('../menu/api.php?action=transferToBot&conversation='+data.id+'&chatid='+data.chatid+'&from='+data.sender+'&body=[transfer]&bot_state=&bot_url='+data.bot_url+'&channel='+data.channel+'&did='+data.did+'&number='+data.phonenumber+'&context='+data.context);
            }
        });
        $('#contact_'+selectedContact).remove();
        $('#chat_'+selectedContact).remove();
        $('#chattransferto').val(null).trigger('change');
        $('.chattransfer').hide();
        $('.conversationtag').hide();
        $('#chat_contact_name').html('');
        $('#chat_transfer_conversation').hide();
        $('#chat_close_conversation').hide();
        $('#chat_menu').hide();
        $('#chat_audiocall').hide();
        $('#call_spy').hide();
        $('.enachatinput').attr('disabled','disabled');
        $('.chatpart').addClass('disabled');
        $('#chat_transfer_conversation').css('background-color','#FFF');

        if($('#chatmonitor_main').is(':visible')) {
            console.log("transfer from chatmonitor, close it");
            $('#history_close').trigger('click');
        } else {
            console.log("transfer direct from agent, do not click history_close button");
        }

    } else {
       setFooterText(sprintf(parent.lang.invaliddestination));
    }
}

async function closeChat(id,exten,channel,did,sender,context) {

    console.log("try close chat id "+id+", exten "+exten+' data closed: '+$('#contact_'+exten).data('closed')+', context: '+context);
    $('.msger-header').css('background','').css('background-color','#fff');
    if($('#contact_'+exten).data('closed')!='closed') {

        fetch('../menu/api.php?action=closeChat&conversation='+id+'&channel='+channel+'&did='+did+'&exten='+exten+'&context='+context).then((response)=>response.json()).then((avdata)=> {

        const msgHTML = `<div class="msg center-msg"> ${parent.lang.closed} </div>`;

        $('#chat_'+exten).get(0).insertAdjacentHTML("beforeend", msgHTML);
        $('#msger-chat').scrollTop($('#msger-chat')[0].scrollHeight);

        $('#contact_'+exten).data('closed','closed');

        $('.enachatinput').attr('disabled','disabled');
        $('.chatpart').addClass('disabled');
        $('#contact_'+exten).remove();
        $('.conversationtag').hide();
        $('#conversationtag').val('');
        $('#conversationtag').data('nochange',1).trigger('change');
        $('.chattransfer').hide();
        $('#chat_menu').hide();
        $('#chat_contact_name').html('');
        $('#chat_close_conversation').hide();
        $('#chat_transfer_conversation').hide();
        $('#chat_audiocall').hide();
        setTimeout(function() {
            $('.msger-inputarea').hide();
            $('#chat_'+exten).html('');
        },1000);

        });

    } else {
        console.log('already closed');
    }

}

function doesContactExists(number,firstname,lastname,channel) {
    return new Promise((resolve,reject) => {
        console.log(number,firstname,lastname,channel);
        console.log("window.parent.plugins['phonepro'].getContactId(number,firstname,lastname,channel)");
        window.parent.plugins['phonepro'].getContactId(number,firstname,lastname,channel).then((data)=>{
            resolve(data);
        });
    });
}

async function getAvatar(sender,assignedto) {
    console.log("get avatar sender "+sender+" assigned to "+assignedto);
    avatar = localstorageCacheGet("avatar_"+sender);
    if(avatar === null) {
        avatar = await getQueuedAvatar(sender,assignedto);
        if(avatar=='') {
            avatar = getLocalAvatar(sender);
        }
        if(avatar=='') {
            seed = sender.replace(/[\u{0080}-\u{FFFF} ]/gu,"");
            if(avatar_url.substring(0,4)=='http') {
                const separator = avatar_url.includes('?') ? '&' : '?';
                avatar = avatar_url+separator+'seed='+seed;
            } else {
                avatar = '../menu/api.php?action=boringavatar&seed='+seed;
            }
            console.log("avatar set cache en getAvatar sender "+sender+" seed "+seed+" avatar="+avatar);
            localstorageCacheSet("avatar_"+sender,avatar,86400);
        }
        console.log("avatar final from query "+avatar);
        return avatar;
    } else {
        console.log("avatar final from cache "+avatar);
        return avatar;
    }
}

async function createOrAssignConversation(number,name,channel,agent,did,provider) {
    console.log("create or assign conversation "+number+" name "+name+" channel "+channel+" agent "+agent+" did "+did+", provider: "+provider);
    console.log('check_if_open_conversation');

    const pageResult = await pocketclient.collection('incomingqueue').getList( 1, 1, {
        filter: 'chatid = "'+number+'" && (state = "assigned" || state ="open")'
    });
    if(pageResult.totalItems==0) {

        let yourDate = new Date();
        let finishdate = yourDate.toISOString().split('T')[0]+' '+yourDate.toISOString().split('T')[1].split('.')[0];
//        let finishdate = yourDate.toISOString().split('T')[0]+' '+yourDate.toISOString().split('T')[1].split('.')[0]+' UTC';
        trimdid = did.toString().replace(/[^A-Za-z0-9_]/g, "");
        let icon = typeof(provider_icon[channel+'_'+trimdid]!='undefined')?provider_icon[channel+'_'+trimdid]:'../imenu/images/sms.webp';

        // TODO get avatar from provider

         fetch('../menu/api.php?action=getAvatar&channel='+channel+'&user='+number).then((response)=>response.json()).then((avdata)=> {

            console.log("createOrAssign: tengo avatar "+avdata.avatar);
            localstorageCacheSet("avatar_"+name,avdata.avatar,86400);
            // TODO setear el cache de avatar aca

            const data = {
                "sender": name,
                "channel": channel,
                "assignedto": agent,
                "state": "originate",
                "did": did,
                "icon": icon,
                "chatid": channel+'_'+number,
                "avatar": avdata.avatar,
                "phonenumber": number,
                "provider": provider,
                "tag": "",
                "finished": finishdate
            }

            console.log('creo queue message');

            const record = pocketclient.collection('incomingqueue').create(data).then((record)=>{ 

                console.log('creo mensaje dummy con record id '+record.id+" and avatar "+avdata.avatar);

                // crear un mensaje dummy
                const mrecord = pocketclient.collection('messages').create({
                    body: parent.lang.operator_start_chat,
                    conversation: record.id,
                    from: number,
                    name: name,
                    avatar: avdata.avatar,
                    direction: 'info'
                }).then((data)=> { 
                    populateLastMessages(); 
                });
            });


        });

    } else {
        if(pageResult.items[0].assignedto!='') {
            parent.alertify.alert('Already in conversation with '+pageResult.items[0].assignedto);
        } else {

            var myid   = pageResult.items[0].id;
            var mychan = pageResult.items[0].channel;
            var mydid  = pageResult.items[0].did;
            var mycrm  = provider_crm[mychan+"_"+mydid];
            var myicon = pageResult.items[0].icon;
console.log("accept chat id "+myid+", chan "+mychan+", did "+mydid+" crm "+mycrm+" icon "+myicon);
             acceptChat(parent.myextension,myicon,myid,mychan,mycrm);
            // if it has an open chat, assigned it to me 
            /*
            const record = await pocketclient.collection('incomingqueue').update( pageResult.items[0].id, {
                assignedto: parent.myextension,
                state: 'assigned',
                transferer: '',
            });*/
        }
        console.log(pageResult.items[0]);
    }
}

async function getQueuedAvatar(sender,assignedto) {
    const pageResult = await pocketclient.collection('incomingqueue').getList( 1, 1, {
        filter: 'sender = "'+sender+'" && assignedto = "'+assignedto+'"'
    });
    var avatar='';
    pageResult.items.forEach(item => {
        avatar = item.avatar;
    });
    if(avatar!='') {
        console.log("avatar set cache en getQueuedAvatar sender "+sender);
        localstorageCacheSet("avatar_"+sender,avatar,86400);
    }
    console.log("get queued avatar return "+avatar);
    return avatar;
}

async function getLocalAvatar(sender,msgid) {
    av = await window.parent.plugins['phonepro'].getImage(sender);
    var avatar = '';
    if(av!='' && av!='[]') {
        avatar = '../../../../uploads/'+av;
        console.log("avatar set cache en getLocalAvatar sender "+sender);
        localstorageCacheSet("avatar_"+sender,avatar,86400);
    }
    console.log("avatar get local avatar sender "+sender+" return "+avatar);
    return avatar;
}

async function acceptChat(extension,icon,conversationid,channel,crm) {

    console.log("accept chat for user "+extension+" with icon "+icon+" on channel "+channel+" and crm "+crm+" and conversation id "+conversationid);
    console.log('update record');
    var agent_name = parent.botonitos[parent.myposition].LABEL;
    const record = await pocketclient.collection('incomingqueue').update( conversationid, {
        assignedto: extension,
        agent: agent_name,
        state: 'assigned',
        transferer: '',
    });

    //var nid = record.chatid.replace(/[^A-Za-z0-9_]/g, "");
    var myid = channel+'_'+record.phonenumber+'_'+record.did;
    var nid = myid.replace(/[^A-Za-z0-9_]/g, "");

    var savatar     = record.avatar;
    var number      = record.phonenumber;
    var sendername  = record.sender;
    var tag         = record.tag;
    var did         = record.did;
    console.log("record:",record);
    console.log("did "+did);

    $('#chat_'+nid).html(''); 
    $('#contact_'+nid).data('closed','');

    const pageResult = await pocketclient.collection('messages').getList( 1, 500, {
        filter: 'conversation = "'+conversationid+'"',
    });

    var phonenumber=number;
    console.log("10 nico phonenumber "+phonenumber);
    if(phonenumber!='chatbroker') {
        phonenumber = phonenumber.replace(/\D+$/g,'');
    }
    console.log("11 nico phonenumber "+phonenumber);

    if(number!='chatbroker') {
        number = number.replace(/\D/g, "");
    }

    if(pageResult.totalItems==0) {
        // es un envio de mensaje, crear contacto 
        console.log("debo crear un contacto con did "+did);
        createContact(number,sendername,icon,conversationid,'',channel,did,phonenumber);
    }

    if(crm!='' && crm!='undefined' && typeof crm!=='undefined') {
        openPopupCrm(crm,record);
    }

    pageResult.items.forEach(item => { 

        var msgid     = item.id;
        var idfrom    = item.from;
        var body      = item.body;

        console.log("Accept Chat: Recibió un mensaje from "+sendername+", number: "+number+", body: "+body);
        var avatar    = item.avatar;

        //seed = finalfrom.replace(/[\u{0080}-\u{FFFF} ]/gu,"");
        //avatar = 'https://avatars.dicebear.com/api/personas/your-'+seed+'-seed.svg';

        var created = item.created;
        year        = created.substr(0,4);
        month       = parseInt(created.substr(5,2))-1;
        day         = created.substr(8,2);
        hour        = created.substr(11,2);
        minute      = created.substr(14,2);
        second      = created.substr(17,2);
        var utcDate = new Date(Date.UTC(year,month,day,hour,minute,second));
        var dateStr = utcDate.getFullYear()+"-"+pad2(utcDate.getMonth())+"-"+pad2(utcDate.getDate())+" "+pad2(utcDate.getHours())+":"+pad2(utcDate.getMinutes())+":"+pad2(utcDate.getSeconds());

        if(item.direction=='inbound') {
            position = 'left';
            avatar   = savatar;
        } else if(item.direction=='outbound') {
            position = 'right';
        } else if(item.direction=='broadcast') {
            position = item.direction;
            avatar = item.avatar;
        } else if(item.direction=='autoreply') {
            position = item.direction;
            //sendername = 'Bot';
            avatar = 'https://avatars.dicebear.com/api/bottts/your-asdf4.svg';
        } else {
            position = item.direction;
            avatar = '';
        }

        var files = [];
        if(item.attachment.length>0) {
            files = [ msgid, item.attachment ];
        }

        appendMessage(phonenumber, msgid, sendername, avatar, position, body, dateStr, icon, conversationid, 0, '', files, channel, 0, did); 

    });

    if($('#chatqueue').children().length==0) {
        $('#pendingchats').hide();
    }
    $('.enachatinput').removeAttr('disabled');
    $('.chatpart').removeClass('disabled');    

    console.log('simulate click on #contact_'+nid);
    $('#contact_'+nid).trigger('click')
    doTrans();
}

function openPopupCrm(url,data) {
    if(url=='undefined') return;
    console.log('crm open popup '+url);
    if(url.indexOf('http')==-1) {
        url = '../menu/crm/'+url+'.php';
    }
    $.ajax(url+"?data="+encodeURIComponent(JSON.stringify(data))).then(function(data) {
        if(data!='') {
            window.open(data,url);
        }
    });
}

function importContact(filename,imgid) {
    url = '../../../../contacts.php?action=importcontact&filename='+filename;
    if($('#'+imgid).attr('src')!='') {
        url+='&photo='+parent.Base64.encode($('#'+imgid).attr('src'));
    }
    $.ajax(url).then(function() {
        parent.$('#contactsframe').attr('src',function(i,val) { return val;});
    });
}

function localstorageCacheSet(key, value, ttl) {
    const now = new Date()
    const item = {
        value: value,
        expiry: now.getTime() + ttl,
    }
    localStorage.setItem(key, JSON.stringify(item))
}

function localstorageCacheGet(key) {
    const itemStr = localStorage.getItem(key)
    if (!itemStr) {
        return null
    }

    const item = JSON.parse(itemStr)
    const now = new Date()

    if (now.getTime() > item.expiry) {
        localStorage.removeItem(key)
        return null
    }
    console.log("got from cache "+item.value);
    return item.value
}

const appendPageNumber = (index) => {
  const pageNumber = document.createElement("button");
  if(index=='first') {
      pageNumber.innerHTML = '<i class="fas fa-angle-double-left"></i>';
      pageNumber.setAttribute("aria-label", "First page");
  } else if(index=='previous') {
      pageNumber.innerHTML = '<i class="fas fa-angle-left"></i>';
      pageNumber.setAttribute("aria-label", "Previous page");
  } else if(index=='next'){ 
      pageNumber.innerHTML = '<i class="fas fa-angle-right"></i>';
      pageNumber.setAttribute("aria-label", "Next page");
  } else if(index=='last') {
      pageNumber.innerHTML = '<i class="fas fa-angle-double-right"></i>';
      pageNumber.setAttribute("aria-label", "Last page");
  } else {
      pageNumber.innerHTML = index;
      pageNumber.setAttribute("aria-label", "Page " + index);
  }
  pageNumber.setAttribute("page-index", index);
  pageNumber.className = "pagination-number";
  $('#pagination-numbers').get(0).appendChild(pageNumber);
};

const handleActivePageNumber = (currentPage) => {
  document.querySelectorAll(".pagination-number").forEach((button) => {
    button.classList.remove("active");
    const pageIndex = Number(button.getAttribute("page-index"));
    if (pageIndex == currentPage) {
      button.classList.add("active");
    }
  });
};

const setCurrentPage = (pageNum,totalPages,reget=1) => {
  pagination_window = 10;
  handleActivePageNumber(pageNum);
  if(pageNum=='first') {
      history_current_page = 1;
  } else if(pageNum=='previous') {
      history_current_page = Number(history_current_page)-1;
  } else if(pageNum=='next') {
      history_current_page = Number(history_current_page)+1;
  } else if(pageNum=='last') {
      history_current_page = Number(totalPages);
  } else {
      history_current_page = Number(pageNum);
  }
  if(history_current_page>totalPages) { history_current_page=totalPages; }
  if(history_current_page<1) { history_current_page=1; }

  if(history_current_page==1) {
      $('.pagination-number[page-index=first]').addClass('disabled').attr('disabled','disabled');
      $('.pagination-number[page-index=previous]').addClass('disabled').attr('disabled','disabled');
  } else {
      $('.pagination-number[page-index=first]').removeClass('disabled').removeAttr('disabled');
      $('.pagination-number[page-index=previous]').removeClass('disabled').removeAttr('disabled');
  }

  if(history_current_page==totalPages) {
      $('.pagination-number[page-index=next]').addClass('disabled').attr('disabled','disabled');
      $('.pagination-number[page-index=last]').addClass('disabled').attr('disabled','disabled');
  }  else {
      $('.pagination-number[page-index=next]').removeClass('disabled').removeAttr('disabled');
      $('.pagination-number[page-index=last]').removeClass('disabled').removeAttr('disabled');
  }

  window_start = Math.floor(history_current_page - (pagination_window/2));
  window_end = Math.floor(history_current_page + (pagination_window/2));

  if(window_start<1) {
      window_end   = window_end + (window_start * -1)+1;
      window_start = 1;
  }

  if(window_end>totalPages) {
      window_start = window_start - (window_end - totalPages);
      window_end = totalPages;
  }

  $('.pagination-number').each(function() {
      var idx = $(this).attr('page-index');
      var idxnum = Number(idx);
      if(idx==idxnum) {
          if(idx>=window_start && idx<=window_end) {
              $(this).show();
          } else {
              $(this).hide();
          }
      }
  });

  if(reget==1) {
      getChatHistory();
  }
};

// handle attachments functions

function DataURIToBlob(dataURI) {
    // converts base64 images to binary blob data for FormdData 
    const splitDataURI = dataURI.split(',')
    const byteString = splitDataURI[0].indexOf('base64') >= 0 ? atob(splitDataURI[1]) : decodeURI(splitDataURI[1])
    const mimeString = splitDataURI[0].split(':')[1].split(';')[0]

    const ia = new Uint8Array(byteString.length)
    for (let i = 0; i < byteString.length; i++) {
        ia[i] = byteString.charCodeAt(i)
    }

    return new Blob([ia], { type: mimeString })
}

async function uploadAttachMessage(body,avatar,to) {
    // insert message into backend and return messageid, checking for attachments
    console.log("start uploadAttachMessage body="+body+",avatar="+avatar+",to="+to);
    
    var conversation = $('#contact_'+selectedContact).data('conversationid');
    var tag = $('#contact_'+selectedContact).data('tag');
    var page = $('#contact_'+selectedContact).data('did');
    const formData = new FormData();

    // this is not needed anymore as internal conversations will have a DB backend entry
    /*
    if(typeof(conversation)=='undefined') {
        return [0,[]];
    }
    */

    if($('#audioblob').length > 0) {
        // whatsappaudio attachments
        console.log("append audio for whatsapp");
        data = $('#audioblob').val();
        filename = new Date().toISOString() + Math.random(12) + '.ogg';
        const xfile = new File([DataURIToBlob(data)],filename, { type: 'audio/ogg' });
        formData.append('attachment',xfile);
        trashRecording();
    } else {
        // myDrop regular attachments
        for(let file of myDrop.getQueuedFiles()) {
           data = await readFile(file);
           const xfile = new File([DataURIToBlob(data)],file.name, { type: file.type });
           formData.append('attachment',xfile);
        }
    }

    if($('#contact_'+selectedContact).attr('data-channel')=='webchat') {
        var tenant_context = parent.context;
        if(tenant_context=='general') { tenant_context=''; }
        if(tenant_context!='') { tenant_context = "_"+tenant_context; }
        formData.append('context', 'webuser'+tenant_context+'_'+page+'_'+to);
    } else if($('#contact_'+selectedContact).attr('data-channel')=='internal') {
        var tenant_context = parent.context;
        if(tenant_context=='general') { tenant_context=''; }
        formData.append('context', tenant_context);
    }

    if(typeof(body)=='undefined') body='';
    formData.append('body',body);
    formData.append('avatar',avatar);
    formData.append('conversation',conversation);
    formData.append('from',parent.myextension);
    formData.append('name',parent.botonitos[parent.myposition]['LABEL']);
    if(tag=='openchannel') {
        formData.append('direction','groupagent');
    } else {
        formData.append('direction','outbound');
    }
    const createRecord = await pocketclient.collection('messages').create(formData);
    myDrop.removeAllFiles();
 
    if($('#contact_'+selectedContact).attr('data-channel')=='internal') {
        console.log('internal channel, insert message for other leg');
        formData.delete('conversation');
        formData.delete('direction');
        var conversation2 = $('#contact_'+selectedContact).data('conversationid2');
        formData.append('conversation',conversation2);
        formData.append('direction','inbound');
        const createRecord2 = await pocketclient.collection('messages').create(formData).then(function() { console.log('create message 2');});
    }
   
    let yourDate = new Date();
    //let finishdate = yourDate.toISOString().split('T')[0]+' '+yourDate.toISOString().split('T')[1].split('.')[0]+' UTC';
    let finishdate = yourDate.toISOString().split('T')[0]+' '+yourDate.toISOString().split('T')[1].split('.')[0];
    const updateFinished = await pocketclient.collection('incomingqueue').update(conversation,{"finished":finishdate});

    return [ createRecord.id, createRecord.attachment];
}

function readFile(file){
    return new Promise((resolve, reject) => {
        var fr = new FileReader();
        fr.onload = () => {
            resolve(fr.result )
        };
        fr.onerror = reject;
        fr.readAsDataURL(file);
    });
}

function filterHistory() {
    return;
    // not used any longer
    console.log('filter history');
    if($('#historysearch').val()=='') {
        $('.trchathistory').show();
    } else {
        $('.trchathistory').each(function() {
            if($(this).text().toLowerCase().indexOf($('#historysearch').val().toLowerCase())>0) { $(this).show(); } else { $(this).hide(); }
        });
    }
}

function showVoicemail() {
    parent.currentVmailbox = parent.myposition
    parent.getVmail(parent.myposition)
    $('#header_chat_icon').removeClass('fa-history').addClass('fa-comment-alt').removeClass('fa-desktop').addClass('fa-inbox');
    $('#msger-chat').removeClass('msger-chat').removeClass('msger-history').removeClass('msger-monitor').addClass('msger-voicemail');
    $('.msger-inputarea').hide();
    $('#chat_'+selectedContact).hide(); // TODO
    $('#chathistory_main').hide();
    $('#chatmonitor_main').hide();
    $('#historysearch').hide();
    $('#menu_chat_history').html(parent.lang.currentchat);
    $('#chat_transfer_conversation').hide();
    $('#chat_close_conversation').hide();
    $('#voicemail_main').show();
    $('.msger-header').css('background','').css('background-color','#fff');
    $('#conversationtag').val('');
    $('#conversationtag').data('nochange',1).trigger('change');
    $('.conversationtag').hide();
    $('.contactchat').hide();
    $('.msger-inputarea').hide();
    $('#chat_contact_name').text(parent.lang['voicemail']);
    $('.chatpart').removeClass('disabled');
    $('#chat_clear').hide();
    $('#chat_audiocall').css('display','inline-block');
    $('.chattransfer').hide();
    selectedContact=extenVoicemail; // TODO
}

function playVmail(folder, file, iconid) {

    console.log("play vmail folder " + folder);
    console.log("play vmail file " + file);
    console.log("play icon " + iconid);

    if (parent.botonitos[parent.myposition]['MAILBOX'] !== undefined) {

        pos = parent.botonitos[parent.myposition]['MAILBOX'].indexOf("@") + 1;
        ctx = parent.botonitos[parent.myposition]['MAILBOX'].substr(pos, parent.botonitos[parent.myposition]['MAILBOX'].length);
        xte = parent.botonitos[parent.myposition]['MAILBOX'].substr(0, pos - 1);

        var hash = parent.hex_md5(parent.lastkey);
        var url = '../../../../setvar.php';
        var pars = {};

        if (parent.voicemailpath.indexOf('dbi:ODBC') >= 0) {
            pars['sesvar'] = 'vfile';
            pars['value'] = file;
            pars2 = parent.hash + "!" + file + "." + parent.voicemailFormat;
            url2 = '../../../../downloadOdbc.php?file=' + pars2;
            console.log("Attempt to download odbc msg " + file);
        } else {
            mfile = parent.voicemailpath + "/" + ctx + "/" + xte + "/" + folder + "/msg" + file + "." + parent.voicemailFormat;
            pars['sesvar'] = 'vfile';
            pars['value'] = mfile;
            pars2 = hash + "!" + mfile;
            url2 = '../../../../download.php?file=' + pars2;
            console.log("Attempt to download disk file " + mfile);
        }

        jQuery.ajax({
            type: 'POST',
            url: url,
            data: pars,
            success: function(output, status) {
                console.log("sesvar ok, now play with " + url2 + " on icon " + iconid);
                if ($('#' + iconid).hasClass('playing')) {
                    //soundPlay(idaudioblock, url2, iconid)
                    doplay(url2,iconid);
console.log('is already playing');
                } else {
                    //soundPlay(idaudioblock, url2, iconid)
                    doplay(url2,iconid);
console.log('do play');
                }
            }
        });

    }

}

function enableChatActionButtons(exten) {
  enable_spy_button(exten);
}

function enable_spy_button(exten) {
  console.log('enable spy '+exten);
  var destino = exten.split("_")[1];
  console.log("enable spy destino "+destino);
  $('#call_spy').hide();
  $('#action_call_spy').hide();
  $('#action_call_whisper').hide();
  $('#call_spy').removeClass();
  $('#call_spy').addClass('btn').addClass('btn-xs').addClass('btn-default').addClass('btn-fop2').addClass('action_button_'+exten);
  if($('#contact_'+exten).hasClass('onthephone')) {
    position = parent.extenpos[destino];
    console.log("is busy position "+position);
    if ( parent.hasPerm(0,'spy') || parent.hasPerm(0,'all') ||  parent.hasPerm(destino,'spy') || parent.hasPerm(destino,'all') ) {
      $('.action_button_'+exten).css('display','inline-block');
      $('#action_call_spy').css('display','inline-block');
    }
    if ( parent.hasPerm(0,'whisper') || parent.hasPerm(0,'all') ||  parent.hasPerm(destino,'whisper') || parent.hasPerm(destino,'all') ) {
      $('.action_button_'+exten).css('display','inline-block');
      $('#action_call_whisper').css('display','inline-block');
    }
    if ( parent.hasPerm(0,'barge') || parent.hasPerm(0,'all') ||  parent.hasPerm(destino,'barge') || parent.hasPerm(destino,'all') ) {
      $('.action_button_'+exten).css('display','inline-block');
      $('#action_call_barge').css('display','inline-block');
    }
  }
}

$.fn.selectRange = function(start, end) {
    // To set textarea select range or cursor position
    if(end === undefined) {
        end = start;
    }
    return this.each(function() {
        if('selectionStart' in this) {
            this.selectionStart = start;
            this.selectionEnd = end;
        } else if(this.setSelectionRange) {
            this.setSelectionRange(start, end);
        } else if(this.createTextRange) {
            var range = this.createTextRange();
            range.collapse(true);
            range.moveEnd('character', end);
            range.moveStart('character', start);
            range.select();
        }
    });
};

function getCookie(name) {
    var cname = name + "=";
    var dc = document.cookie;
    if (dc.length > 0) {
        begin = dc.indexOf(cname);
        if (begin != -1) {
            begin += cname.length;
            end = dc.indexOf(";", begin);
            if (end == -1) {
                end = dc.length;
            }
            return unescape(dc.substring(begin, end));
        }
    }
    return null;
}

function metadataTable(conversationid,metaelement,metaprefix,showend,showagent,updatestart,from_manager) {

    console.log(metaelement);
  //metaelement.get(0).insertAdjacentHTML("beforeend", `<div class="infomsg"><table class="table table-condensed table-noborders" style="margin-bottom:0;">
  metaelement.insertAdjacentHTML("beforeend", `<div class="infomsg"><table class="table table-condensed table-noborders" style="margin-bottom:0;">
      <tr><td data-trans="Channel">Channel</td><td>
      <img class="history-img" id="chimg${conversationid}" src="../menu/images/whatsapp.webp">
      <span id="msgchannel${conversationid}"></span></td></tr>
      <tr><td data-trans="Start">Start</td><td><span id="msgstarted${conversationid}" class="hidden ${updatestart}"></span><span id="msgstartedago${conversationid}"</span></td></tr>
      <tr class="${showend}"><td data-trans="End">End</td><td> <span id="msgended${conversationid}"></span></td></tr>
      <tr class="${showagent}"><td data-trans="Agent">Agent</td><td><span id="msgagent${conversationid}"></span></td></tr>
      <tr class='msgrating${conversationid}'><td data-trans="csat_rating">CSAT Rating</td><td><span id="msgrating${conversationid}"></td></tr>
      <tr class='msgfeedback${conversationid}'><td data-trans="CSAT Feedback">CSAT Feedback</td><td><span id="msgfeedback${conversationid}"></td></tr></table>
      </div>`);

  getHistoryMetadata(conversationid).then(function(historydata) {

      console.log("get metadata returned:",historydata);

      if(typeof(provider_tags)!='undefined') {
          $('#conversationtag').select2('destroy');
          mydid = historydata.did.replace(/[^A-Za-z0-9_]/g, "");

          var available_tags = provider_tags[historydata.channel+'_'+mydid];
          $('#conversationtag').find('option').remove().end();

          if(available_tags !== undefined) {
              
            $('#conversationtag').append($('<option>', {
                value: '',
                text: ''
            }));
            
            available_tags.split(",").map(function(val) {
                $('#conversationtag').append($('<option>', {
                  value: val,
                  text: val
                }));
            });
          }
          $('#conversationtag').val('');
          $select = $('#conversationtag').select2({ minimumResultsForSearch: -1, placeholder: parent.lang['Tag'] });
          $select.data('select2').$container.addClass('conversationtag').show();
          //console.log("nico papa conversation tag show");
      }

      year        = historydata.created.substr(0,4);
      month       = parseInt(historydata.created.substr(5,2));
      day         = historydata.created.substr(8,2);
      hour        = historydata.created.substr(11,2);
      minute      = historydata.created.substr(14,2);
      second      = historydata.created.substr(17,2);
      var utcDate = new Date(Date.UTC(year,month,day,hour,minute,second));
      dateStr = utcDate.getFullYear()+"-"+pad2(utcDate.getMonth())+"-"+pad2(utcDate.getDate())+" "+pad2(utcDate.getHours())+":"+pad2(utcDate.getMinutes())+":"+pad2(utcDate.getSeconds());
      $('#msgstarted'+conversationid).html(dateStr);
      if(metaprefix=='history') {
          $('#msgstartedago'+conversationid).html(dateStr);
      } else {
          $('#msgstartedago'+conversationid).html(parent.moment($('#msgstarted'+conversationid).text()).fromNow());
      }

      year        = historydata.finished.substr(0,4);
      month       = parseInt(historydata.finished.substr(5,2));
      day         = historydata.finished.substr(8,2);
      hour        = historydata.finished.substr(11,2);
      minute      = historydata.finished.substr(14,2);
      second      = historydata.finished.substr(17,2);
      var utcDate = new Date(Date.UTC(year,month,day,hour,minute,second));
      dateStr = utcDate.getFullYear()+"-"+pad2(utcDate.getMonth())+"-"+pad2(utcDate.getDate())+" "+pad2(utcDate.getHours())+":"+pad2(utcDate.getMinutes())+":"+pad2(utcDate.getSeconds());
      $('#msgended'+conversationid).html(dateStr);

      var agent_name   = historydata.agent;
      $('#msgagent'+conversationid).html(historydata.assignedto+' '+agent_name);

      //var channel_name = provider_name[historydata.channel+'_'+historydata.did];
      var channel_name = historydata.provider;

      $('#msgchannel'+conversationid).html(channel_name);

      if(from_manager==1) {
        historydata.icon = 'plugins/phonepro/menu/'+historydata.icon;
      }

      $('#chimg'+conversationid).attr('src',historydata.icon);

      if(historydata.csat_rating==0) {
        $('.msgrating'+conversationid).hide();
      } else {
        $('#msgrating'+conversationid).html(printStars(historydata.csat_rating));
      }
      if(historydata.csat_rating=='') {
        $('.msgfeedback'+conversationid).hide();
      } else {
        $('#msgfeedback'+conversationid).html(historydata.csat_feedback);
      }
  })

  $('[data-trans]').each(function() {
      translang = {};
      if(typeof(parent.lang)!='undefined') {
          translang = parent.lang;
      } else if(typeof(lang)!='undefined') {
          translang = lang;
      }
      if(typeof(translang[$(this).data('trans')])!='undefined') {
          newtext = translang[$(this).data('trans')];
      } else {
          newtext = $(this).data('trans');
      }
      $(this).text(newtext);
  });

}
